-- Custom Skin handlers (In this situation, this must be declared before the skin table. If loaded after, it would not have a chance to load and an error would be thrown.)
local function formatDetails(guild, level, race, class)
    if(guild ~= "") then
	guild = "<"..guild.."> ";
    end
    return "|cffffffff"..guild..level.." "..race.." "..class.."|r";
end





--Default window skin
WIM_ClassicSkin = {
    title = "WIM Classic",
    version = "1.0.0",
    author = "Pazza [Bronzebeard]",
    website = "http://www.wimaddon.com",
    default_style = "default",
    default_font = "ChatFontNormal",
    smart_style = nil, -- acknowledge that this parameter exists although not needed.
    styles = {
        default = "Default",
        blue = "Blue",
        green = "Green",
        red = "Red",
        yellow = "Yellow"
    },
    message_window = {
        file = {
            default = "Interface\\AddOns\\WIM\\skins\\default\\message_window",
            blue = "Interface\\AddOns\\WIM\\skins\\default\\message_window_blue",
            green = "Interface\\AddOns\\WIM\\skins\\default\\message_window_green",
            red = "Interface\\AddOns\\WIM\\skins\\default\\message_window_red",
            yellow = "Interface\\AddOns\\WIM\\skins\\default\\message_window_yellow"
        },
        rect = {
            top_left = {
                size = {
                    x = 64,
                    y = 64,
                },
                offset = {
                    x = 0,
                    y = 0
                },
                texture_coord = {0, 0, 0, .25, .25, 0, .25, .25}
            },
            top_right = {
                size = {
                    x = 64,
                    y = 64,
                },
                offset = {
                    x = 0,
                    y = 0
                },
                texture_coord = {.75, 0, .75, .25, 1, 0, 1, .25}
            },
            bottom_left = {
                size = {
                    x = 64,
                    y = 64,
                },
                offset = {
                    x = 0,
                    y = 0
                },
                texture_coord = {0, .75, 0, 1, .25, .75, .25, 1}
            },
            bottom_right = {
                size = {
                    x = 64,
                    y = 64,
                },
                offset = {
                    x = 0,
                    y = 0
                },
                texture_coord = {.75, .75, .75, 1, 1, .75, 1, 1}
            },
            top = {
                texture_coord = {.25, 0, .25, .25, .75, 0, .75, .25}
            },
            bottom = {
                texture_coord = {.25, .75, .25, 1, .75, .75, .75, 1}
            },
            left = {
                texture_coord = {0, .25, 0, .75, .25, .25, .25, .75}
            },
            right = {
                texture_coord = {.75, .25, .75, .75, 1, .25, 1, .75}
            },
            background = {
                texture_coord = {.25, .25, .25, .75, .75, .25, .75, .75}
            }
        },
        class_icon = {
            file = {
                default = "Interface\\AddOns\\WIM\\skins\\default\\class_icons",
                blue = "Interface\\AddOns\\WIM\\skins\\default\\class_icons",
                green = "Interface\\AddOns\\WIM\\skins\\default\\class_icons",
                red = "Interface\\AddOns\\WIM\\skins\\default\\class_icons",
                yellow = "Interface\\AddOns\\WIM\\skins\\default\\class_icons"
            },
            rect = {
                size = {
                    x = 64,
                    y = 64
                },
                anchor = "TOPLEFT",
                offset = {
                    x = -10,
                    y = 12
                }
            },
            blank = {.5, .5, .5, .75, .75, .5, .75, .75},
            druid = {0, 0, 0, .25, .25, 0, .25, .25},
            hunter = {.25, 0, .25, .25, .5, 0, .5, .25},
            mage = {.5, 0, .5, .25, .75, 0, .75, .25},
            paladin = {.75, 0, .75, .25, 1, 0, 1, .25},
            priest = {0, .25, 0, .5, .25, .25, .25, .5},
            rogue = {.25, .25, .25, .5, .5, .25, .5, .5},
            shaman = {.5, .25, .5, .5, .75, .25, .75, .5},
            warlock = {.75, .25, .75, .5, 1, .25, 1, .5},
            warrior = {0, .5, 0, .75, .25, .5, .25, .75},
            gm = {.25, .5, .25, .75, .5, .5, .5, .75}
        },
        strings = {
            from = {
                rect = {
                    anchor = "TOPLEFT",
                    offset = {
                        x = 50,
                        y = -8
                    }
                },
                inherits_font = "GameFontNormalLarge"
            },
            char_info = {
                format = formatDetails,
                rect = {
                    anchor = "TOP",
                    offset = {
                        x = 0,
                        y = -30
                    }
                },
                inherits_font = "GameFontNormal",
                color = {1, 1, 1}
            }
        },
        buttons = {
            close = {
                NormalTexture = {
                    default = "Interface\\Buttons\\UI-Panel-MinimizeButton-Up",
                    blue = "Interface\\Buttons\\UI-Panel-MinimizeButton-Up",
                    green = "Interface\\Buttons\\UI-Panel-MinimizeButton-Up",
                    red = "Interface\\Buttons\\UI-Panel-MinimizeButton-Up",
                    yellow = "Interface\\Buttons\\UI-Panel-MinimizeButton-Up"
                },
                PushedTexture = {
                    default = "Interface\\Buttons\\UI-Panel-MinimizeButton-Down",
                    blue = "Interface\\Buttons\\UI-Panel-MinimizeButton-Down",
                    green = "Interface\\Buttons\\UI-Panel-MinimizeButton-Down",
                    red = "Interface\\Buttons\\UI-Panel-MinimizeButton-Down",
                    yellow = "Interface\\Buttons\\UI-Panel-MinimizeButton-Down"
                },
                HighlightTexture = {
                    default = "Interface\\Buttons\\UI-Panel-MinimizeButton-Highlight",
                    blue = "Interface\\Buttons\\UI-Panel-MinimizeButton-Highlight",
                    green = "Interface\\Buttons\\UI-Panel-MinimizeButton-Highlight",
                    red = "Interface\\Buttons\\UI-Panel-MinimizeButton-Highlight",
                    yellow = "Interface\\Buttons\\UI-Panel-MinimizeButton-Highlight"
                },
                rect = {
                    size = {
                        x = 32,
                        y = 32,
                    },
                    anchor = "TOPRIGHT",
                    offset = {
                        x = 4,
                        y = 1
                    }
                }
            },
            history = {
                NormalTexture = {
                    default = "Interface\\Buttons\\UI-GuildButton-PublicNote-Up",
                    blue = "Interface\\Buttons\\UI-GuildButton-PublicNote-Up",
                    green = "Interface\\Buttons\\UI-GuildButton-PublicNote-Up",
                    red = "Interface\\Buttons\\UI-GuildButton-PublicNote-Up",
                    yellow = "Interface\\Buttons\\UI-GuildButton-PublicNote-Up"
                },
                PushedTexture = {
                    default = "Interface\\Buttons\\UI-GuildButton-PublicNote-Up",
                    blue = "Interface\\Buttons\\UI-GuildButton-PublicNote-Up",
                    green = "Interface\\Buttons\\UI-GuildButton-PublicNote-Up",
                    red = "Interface\\Buttons\\UI-GuildButton-PublicNote-Up",
                    yellow = "Interface\\Buttons\\UI-GuildButton-PublicNote-Up"
                },
                HighlightTexture = {
                    default = "Interface\\Buttons\\UI-GuildButton-PublicNote-Up",
                    blue = "Interface\\Buttons\\UI-GuildButton-PublicNote-Up",
                    green = "Interface\\Buttons\\UI-GuildButton-PublicNote-Up",
                    red = "Interface\\Buttons\\UI-GuildButton-PublicNote-Up",
                    yellow = "Interface\\Buttons\\UI-GuildButton-PublicNote-Up"
                },
                rect = {
                    size = {
                        x = 19,
                        y = 19
                    },
                    anchor = "TOPRIGHT",
                    offset = {
                        x = -28,
                        y = -6
                    }
                }
            },
            w2w = {
                NormalTexture = {
                    default = "Interface\\AddOns\\WIM\\Images\\w2w.tga",
                    blue = "Interface\\AddOns\\WIM\\Images\\w2w.tga",
                    green = "Interface\\AddOns\\WIM\\Images\\w2w.tga",
                    red = "Interface\\AddOns\\WIM\\Images\\w2w.tga",
                    yellow = "Interface\\AddOns\\WIM\\Images\\w2w.tga"
                },
                PushedTexture = {
                    default = "Interface\\AddOns\\WIM\\Images\\w2w.tga",
                    blue = "Interface\\AddOns\\WIM\\Images\\w2w.tga",
                    green = "Interface\\AddOns\\WIM\\Images\\w2w.tga",
                    red = "Interface\\AddOns\\WIM\\Images\\w2w.tga",
                    yellow = "Interface\\AddOns\\WIM\\Images\\w2w.tga"
                },
                HighlightTexture = {
                    default = "Interface\\AddOns\\WIM\\Images\\w2w.tga",
                    blue = "Interface\\AddOns\\WIM\\Images\\w2w.tga",
                    green = "Interface\\AddOns\\WIM\\Images\\w2w.tga",
                    red = "Interface\\AddOns\\WIM\\Images\\w2w.tga",
                    yellow = "Interface\\AddOns\\WIM\\Images\\w2w.tga"
                },
                rect = {
                    size = {
                        x = 32,
                        y = 32
                    },
                    anchor = "TOPLEFT",
                    offset = {
                        x = -16,
                        y = 4
                    }
                }
            },
            chatting = {
                NormalTexture = {
                    default = "Interface\\GossipFrame\\PetitionGossipIcon",
                    blue = "Interface\\GossipFrame\\PetitionGossipIcon",
                    green = "Interface\\GossipFrame\\PetitionGossipIcon",
                    red = "Interface\\GossipFrame\\PetitionGossipIcon",
                    yellow = "Interface\\GossipFrame\\PetitionGossipIcon"
                },
                PushedTexture = {
                    default = "Interface\\GossipFrame\\PetitionGossipIcon",
                    blue = "Interface\\GossipFrame\\PetitionGossipIcon",
                    green = "Interface\\GossipFrame\\PetitionGossipIcon",
                    red = "Interface\\GossipFrame\\PetitionGossipIcon",
                    yellow = "Interface\\GossipFrame\\PetitionGossipIcon"
                },
                rect = {
                    size = {
                        x = 16,
                        y = 16
                    },
                    anchor = "TOPLEFT",
                    offset = {
                        x = 40,
                        y = -28
                    }
                }
            },
            scroll_up = {
                NormalTexture = {
                    default = "Interface\\Buttons\\UI-ScrollBar-ScrollUpButton-Up",
                    blue = "Interface\\Buttons\\UI-ScrollBar-ScrollUpButton-Up",
                    green = "Interface\\Buttons\\UI-ScrollBar-ScrollUpButton-Up",
                    red = "Interface\\Buttons\\UI-ScrollBar-ScrollUpButton-Up",
                    yellow = "Interface\\Buttons\\UI-ScrollBar-ScrollUpButton-Up"
                },
                PushedTexture = {
                    default = "Interface\\Buttons\\UI-ScrollBar-ScrollUpButton-Down",
                    blue = "Interface\\Buttons\\UI-ScrollBar-ScrollUpButton-Down",
                    green = "Interface\\Buttons\\UI-ScrollBar-ScrollUpButton-Down",
                    red = "Interface\\Buttons\\UI-ScrollBar-ScrollUpButton-Down",
                    yellow = "Interface\\Buttons\\UI-ScrollBar-ScrollUpButton-Down"
                },
                HighlightTexture = {
                    default = "Interface\\Buttons\\UI-ScrollBar-ScrollUpButton-Highlight",
                    blue = "Interface\\Buttons\\UI-ScrollBar-ScrollUpButton-Highlight",
                    green = "Interface\\Buttons\\UI-ScrollBar-ScrollUpButton-Highlight",
                    red = "Interface\\Buttons\\UI-ScrollBar-ScrollUpButton-Highlight",
                    yellow = "Interface\\Buttons\\UI-ScrollBar-ScrollUpButton-Highlight"
                },
                DisabledTexture = {
                    default = "Interface\\Buttons\\UI-ScrollBar-ScrollUpButton-Disabled",
                    blue = "Interface\\Buttons\\UI-ScrollBar-ScrollUpButton-Disabled",
                    green = "Interface\\Buttons\\UI-ScrollBar-ScrollUpButton-Disabled",
                    red = "Interface\\Buttons\\UI-ScrollBar-ScrollUpButton-Disabled",
                    yellow = "Interface\\Buttons\\UI-ScrollBar-ScrollUpButton-Disabled"
                },
                rect = {
                    size = {
                        x = 32,
                        y = 32
                    },
                    anchor = "TOPRIGHT",
                    offset = {
                        x = -4,
                        y = -39
                    }
                }
            },
            scroll_down = {
                NormalTexture = {
                    default = "Interface\\Buttons\\UI-ScrollBar-ScrollDownButton-Up",
                    blue = "Interface\\Buttons\\UI-ScrollBar-ScrollDownButton-Up",
                    green = "Interface\\Buttons\\UI-ScrollBar-ScrollDownButton-Up",
                    red = "Interface\\Buttons\\UI-ScrollBar-ScrollDownButton-Up",
                    yellow = "Interface\\Buttons\\UI-ScrollBar-ScrollDownButton-Up"
                },
                PushedTexture = {
                    default = "Interface\\Buttons\\UI-ScrollBar-ScrollDownButton-Down",
                    blue = "Interface\\Buttons\\UI-ScrollBar-ScrollDownButton-Down",
                    green = "Interface\\Buttons\\UI-ScrollBar-ScrollDownButton-Down",
                    red = "Interface\\Buttons\\UI-ScrollBar-ScrollDownButton-Down",
                    yellow = "Interface\\Buttons\\UI-ScrollBar-ScrollDownButton-Down"
                },
                HighlightTexture = {
                    default = "Interface\\Buttons\\UI-ScrollBar-ScrollDownButton-Highlight",
                    blue = "Interface\\Buttons\\UI-ScrollBar-ScrollDownButton-Highlight",
                    green= "Interface\\Buttons\\UI-ScrollBar-ScrollDownButton-Highlight",
                    red = "Interface\\Buttons\\UI-ScrollBar-ScrollDownButton-Highlight",
                    yellow = "Interface\\Buttons\\UI-ScrollBar-ScrollDownButton-Highlight"
                },
                DisabledTexture = {
                    default = "Interface\\Buttons\\UI-ScrollBar-ScrollDownButton-Disabled",
                    blue = "Interface\\Buttons\\UI-ScrollBar-ScrollDownButton-Disabled",
                    green = "Interface\\Buttons\\UI-ScrollBar-ScrollDownButton-Disabled",
                    red = "Interface\\Buttons\\UI-ScrollBar-ScrollDownButton-Disabled",
                    yellow = "Interface\\Buttons\\UI-ScrollBar-ScrollDownButton-Disabled"
                },
                rect = {
                    size = {
                        x = 32,
                        y = 32
                    },
                    anchor = "BOTTOMRIGHT",
                    offset = {
                        x = -4,
                        y = 24
                    }
                }
            }
        },
        chat_display = {
            rect = {
                tl_offset = {
                    x = 24,
                    y = -46
                },
                br_offset = {
                    x = -38,
                    y = 39
                }
            }
        },
        msg_box = {
            font_height = 14,
            font_color = {1,1,1},
            rect = {
                tl_offset = {
                    x = 22,
                    y = 35
                },
                br_offset = {
                    x = -10,
                    y = 0
                }
            }
        },
        shortcuts = {
            verticle = true,
            inverted = false,
            button_size = 28,
            buffer = 132,
            rect = {
                anchor = "TOPRIGHT",
                offset = {
                    x = -30,
                    y = -95
                }
            }
        }
    },
    tab_strip = {
        rect = {
            anchor_points = {
                self = "BOTTOMLEFT",
                relative = "TOPLEFT"
            },
            offsets = {
                top = -4,
                margins = {
                    left = 38,
                    right = 15
                }
            }
        }
    }
};

----------------------------------------------------------
--                  Register Skin                       --
----------------------------------------------------------

WIM_RegisterSkin(WIM_ClassicSkin);